#ifndef LIB_DEFAULT_NOPSMDRM_H
#define LIB_DEFAULT_NOPSMDRM_H
#include "log.h"

#define FAKE_AID 0x0123456789ABCDEFLL
#define FAKE_LICENSE_OUTPUT "/sdcard/psm"
#define DUMP_ALL_FLAG_FILE (FAKE_LICENSE_OUTPUT "/dump_all")

typedef struct
{
    char magic[0x8];             // 0x00
    uint32_t unk1;               // 0x08
    uint32_t unk2;               // 0x0C
    uint64_t aid;                // 0x10
    uint32_t unk3;               // 0x18
    uint32_t unk4;               // 0x1C
    uint64_t start_time;         // 0x20
    uint64_t expiration_time;    // 0x28
    uint8_t act_digest[0x20];    // 0x30
    char content_id[0x30];       // 0x50
    uint8_t unk5[0x80];          // 0x80
    uint8_t key[0x200];          // 0x100
    uint8_t sha256digest[0x100]; // 0x300
} ScePsmDrmLicense;


int patch_nopsmdrm();

#endif //LIB_DEFAULT_NOPSMDRM_H
